{**********************************************************************
                PilotLogic Software House
  
 Package pl_FPSpreadsheet
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)
***********************************************************************}

unit allspreadsheetreg;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LCLIntf, LCLType, LMessages,
  TypInfo, lresources, PropEdits, ComponentEditors,
  fpspreadsheetgrid,
  fpspreadsheetchart,
  fpspreadsheetctrls,
  xlsxooxml_crypto,
  //fpdataexporter,
  ActnList,
  fpsActions,
  fpsexport;


  procedure Register;

implementation
{$R allspreadsheetreg.res}

procedure Register;
begin
   RegisterComponents('Spreadsheet',[
                                     TsWorksheetGrid,

                                     TsWorkbookSource,
                                     TsWorkbookTabControl, TsWorksheetIndicator,
                                     TsCellEdit, TsCellIndicator, TsCellCombobox,
                                     TsSpreadsheetInspector,

                                     TsWorksheetChartSource,
                                     TsWorkbookChartSource,

                                     TFPSExport
                                        ]);
                                       

  RegisterActions('FPSpreadsheet', [
    // Worksheet-releated actions
    TsWorksheetAddAction, TsWorksheetDeleteAction, TsWorksheetRenameAction,
    TsWorksheetZoomAction,
    // Cell or cell range formatting actions
    TsCopyAction,
    TsClearFormatAction,
    TsFontStyleAction, TsFontDialogAction, TsBackgroundColorDialogAction,
    TsHorAlignmentAction, TsVertAlignmentAction,
    TsTextRotationAction, TsWordWrapAction,
    TsNumberFormatAction, TsDecimalsAction,
    TsCellProtectionAction,
    TsCellBorderAction, TsNoCellBordersAction,
    TsCellCommentAction, TsCellHyperlinkAction,
    TsMergeAction
  ], nil);

  RegisterPropertyEditor(TypeInfo(TFileName),
    TsWorkbookSource, 'FileName', TFileNamePropertyEditor
  );
                                                                      
end;

initialization

  RegisterPropertyToSkip(TsSpreadsheetInspector, 'RowHeights', 'For compatibility with older Typhon versions.', '');
  RegisterPropertyToSkip(TsSpreadsheetInspector, 'ColWidths',  'For compatibility with older Typhon versions.', '');

  RegisterPropertyToSkip(TsCustomWorksheetGrid, 'ColWidths',  'taken from worksheet', '');
  RegisterPropertyToSkip(TsCustomWorksheetGrid, 'RowHeights', 'taken from worksheet', '');

end.

